package rd.NADemo;

// NADemo
// Copyright R&D Computer System Co., Ltd.

import android.Manifest;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.content.DialogInterface;
import android.content.pm.PackageManager;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.HandlerThread;
import android.os.Looper;
import android.os.Message;
import android.text.InputFilter;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.TextUtils;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

import rd.nalib.NA;
import rd.nalib.ResponseListener;

public class MainActivity extends AppCompatActivity {

    public static final int MY_PERMISSIONS = 0;
    private static final int RED = 0x88FF0000;
    private static final int GREEN = 0x88196F3D;
    private static final int WHITE = 0xFFFFFFFF;

    private static final int NA_NO_AText = 0x00;
    private static final int NA_AText = 0x01;

    NA NALibs;
    private final Handler handler = new Handler();
    Button bt_scanreader, bt_listoption, bt_cardinfo, bt_getrid, bt_selectreader, bt_deselectreader, bt_connectcard, bt_disconnectcard, bt_readdata, bt_readnumber, bt_readphoto, bt_readAText, bt_getlicenseinfo, bt_updatelicensefile, bt_exit;
    LinearLayout ll_connect;
    Spinner spinner;
    ImageView iv_faceimage;
    ScrollView scrollView;
    TextView tv_SoftwareInfo, tv_connected, tv_output;
    HandlerThread myThread;
    MyHandler mHandler;
    String mNIDReader = "/" + "NADemo";
    String LICFileName = "/" + "rdnidlib.dls";
    String LicFile = "";
    String Parameter_OpenLib = "";
    BluetoothAdapter mBluetoothAdapter;
    String nameDevice = "";
    ActionBar actionBar;
    private String NAVersion;
    String MessegeText = "";
    ResponseListener responseListener = new ResponseListener() {

        @Override
        public void onOpenLibNA(int Result) {
            String mode = "";
            if (Parameter_OpenLib.compareTo("") == 0) {
                mode = " (For Virtual Licensing readers only)";
                handler.post(new Runnable() {
                    public void run() {
                        actionBar.setTitle("NADemo " + NAVersion + " (VL only)");
                    }
                });
            }
            String Output = "openLibNA(\"" + Parameter_OpenLib + "\")" + "\n" + "   Result > " + Result + mode;
            Output = Output + "\n" + "------------------------------";

            if (Result == 0) {
                String[] data = new String[1];
                Result = NALibs.getSoftwareInfoNA(data);
                if (Result == 0)
                    tv_SoftwareInfo.setText(data[0]);
            }

            setResultText(Output);
            setEnableButton();

        }

        @Override
        public void onGetReaderListNA(final ArrayList<String> readerList, int Result) {
            if (Result == 0) {
                String Output = "getReaderListNA (" + bt_listoption.getText().toString().substring(bt_listoption.length() - 2, bt_listoption.length()) + ")" + "\n" + "   Return > " + readerList.size();
                for (String d : readerList) {
                    Output = Output + "\n" + "   Result > " + d;
                }
                Output = Output + "\n" + "------------------------------";
                setResultText(Output);
            } else if (Result > 0) {
                handler.post(new Runnable() {
                    public void run() {
                        ArrayAdapter<String> adapter = new ArrayAdapter<>(MainActivity.this, R.layout.spinner_item, readerList);
                        spinner.setAdapter(adapter);
                    }
                });
                String Output = "getReaderListNA (" + bt_listoption.getText().toString().substring(bt_listoption.length() - 2, bt_listoption.length()) + ")" + "\n" + "   Return > " + readerList.size();
                for (String d : readerList) {
                    Output = Output + "\n" + "   Result > " + d;
                }
                Output = Output + "\n" + "------------------------------";
                setResultText(Output);
            } else {
                handler.post(new Runnable() {
                    public void run() {
                        ArrayAdapter<String> adapter = new ArrayAdapter<>(MainActivity.this, R.layout.spinner_item);
                        spinner.setAdapter(adapter);
                    }
                });
                String Output = "getReaderListNA (" + bt_listoption.getText().toString().substring(bt_listoption.length() - 2, bt_listoption.length()) + ")" + "\n" + "   Return > " + Result;
                Output = Output + "\n" + "------------------------------";
                setResultText(Output);
            }
            setEnableButton();
        }

        @Override
        public void onSelectReaderNA(int Result) {
            if (Result == 0) {
                handler.post(new Runnable() {
                    public void run() {
                        tv_connected.setText(nameDevice + ": Selected");
                        ll_connect.setBackgroundColor(GREEN);
                        tv_connected.setTextColor(WHITE);
                    }
                });

            } else {
                handler.post(new Runnable() {
                    public void run() {
                        tv_connected.setText("");
                        ll_connect.setBackgroundColor(RED);
                        tv_connected.setTextColor(WHITE);
                    }
                });
            }
            String Output = "selectReaderNA (\"" + nameDevice + "\")" + "\n" + "   Return > " + Result;
            Output = Output + "\n" + "------------------------------";

            if (Result == 0) {
                Output = Output + "\n";
                String[] data = new String[1];
                Result = NALibs.getReaderInfoNA(data);
                Output = Output + "getReaderInfoNA" + "\n" + "   Return > " + Result;
                if (Result == 0) {
                    Output = Output + "\n" + "   Result > " + data[0];
                }
                Output = Output + "\n" + "------------------------------";
            }

            setResultText(Output);
            setEnableButton();
        }

        @Override
        public void onGetNIDNumberNA(String cardData, int Result) {
            String Output = "getNIDNumberNA" + "\n" + "   Return > " + Result;
            if (Result == 0) {
                Output = Output + "\n" + "   Result > " + cardData;
            }
            Output = Output + "\n" + "------------------------------";
            setResultText(Output);
            setEnableButton();
        }

        @Override
        public void onGetNIDTextNA(String cardData, int Result) {
            String Output;
            if (MessegeText.compareTo("readdata") == 0)
                Output = "getNIDTextNA()" + "\n" + "   Return > " + Result;
            else
                Output = "getNIDTextNA(1)" + "\n" + "   Return > " + Result;
            if (Result == 0) {
                Output = Output + "\n" + "   Result > " + cardData;
            }
            Output = Output + "\n" + "------------------------------";
            setResultText(Output);
            setEnableButton();
        }


        @Override
        public void onGetNIDPhotoNA(final byte[] cardData, int Result) {
            String Output = "getNIDPhotoNA" + "\n" + "   Return > " + Result;
            if (Result == 0) {
                handler.post(new Runnable() {
                    public void run() {
                        Bitmap bMap = BitmapFactory.decodeByteArray(cardData, 0, cardData.length);
                        iv_faceimage.setImageBitmap(bMap);
                    }
                });
            }
            Output = Output + "\n" + "------------------------------";
            setResultText(Output);
            setEnableButton();
        }

        @Override
        public void onUpdateLicenseFileNA(int Result) {
            String Output = "updateLicenseFileNA" + "\n" + "   Return > " + Result;
            Output = Output + "\n" + "------------------------------";
            setResultText(Output);
            setEnableButton();
        }

    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        try {
            NAVersion = getPackageManager().getPackageInfo(getPackageName(), 0).versionName;
        } catch (PackageManager.NameNotFoundException e) {
            e.printStackTrace();
        }
        actionBar = getSupportActionBar();
        actionBar.setTitle("NADemo " + NAVersion);
        myThread = new HandlerThread("Worker Thread");
        myThread.start();
        Looper mLooper = myThread.getLooper();
        mHandler = new MyHandler(mLooper);

        LicFile = getFilesDir() + mNIDReader + LICFileName;
        Parameter_OpenLib = LicFile;

        NALibs = new NA(this);
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

        tv_SoftwareInfo = findViewById(R.id.tv_SoftwareInfo);
        ll_connect = findViewById(R.id.ll_connect);
        tv_connected = findViewById(R.id.tv_connected);
        tv_output = findViewById(R.id.tv_output);
        spinner = findViewById(R.id.spinner);
        iv_faceimage = findViewById(R.id.iv_faceimage);
        scrollView = findViewById(R.id.scrollview);
        bt_listoption = findViewById(R.id.bt_listoption);
        bt_listoption.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final EditText edittext = new EditText(MainActivity.this);
                final TextView textview = new TextView(MainActivity.this);
                edittext.setFilters(new InputFilter[]{
                        new HexadecimalInputFilter(true),
                        new InputFilter.LengthFilter(2),
                });
                final AlertDialog alert = new AlertDialog.Builder(MainActivity.this)
                        .setTitle("Set List Option")
                        .setView(edittext)
                        .setPositiveButton("Set", null) //Set to null. We override the onclick
                        .setNegativeButton("Cancel", null)
                        .create();
                edittext.setText(bt_listoption.getText().toString().replaceAll("List Option: ", ""));
                alert.setOnShowListener(new DialogInterface.OnShowListener() {

                    @Override
                    public void onShow(DialogInterface dialogInterface) {
                        Button button1 = (alert).getButton(AlertDialog.BUTTON_POSITIVE);
                        button1.setOnClickListener(new View.OnClickListener() {

                            @Override
                            public void onClick(View view) {
                                if (edittext.getText().toString().length() < 2) {
                                    textview.setTextColor(Color.RED);
                                    textview.setText("Length must be 2");

                                } else {
                                    bt_listoption.setText("List Option: " + edittext.getText().toString());
                                    alert.dismiss();
                                }
                            }
                        });

                        Button button2 = (alert).getButton(AlertDialog.BUTTON_NEGATIVE);
                        button2.setOnClickListener(new View.OnClickListener() {

                            @Override
                            public void onClick(View view) {
                                alert.dismiss();
                            }
                        });
                    }
                });

                alert.show();
            }
        });
        bt_scanreader = findViewById(R.id.bt_scanreader);
        bt_scanreader.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "getreaderlist";
                mHandler.sendMessage(msg);
            }
        });
        bt_selectreader = findViewById(R.id.bt_selectreader);
        bt_selectreader.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "selectreader";
                mHandler.sendMessage(msg);
            }
        });
        bt_deselectreader = findViewById(R.id.bt_deselectreader);
        bt_deselectreader.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "deselectreader";
                mHandler.sendMessage(msg);
            }
        });
        bt_connectcard = findViewById(R.id.bt_connectcard);
        bt_connectcard.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "connectcard";
                mHandler.sendMessage(msg);
            }
        });
        bt_disconnectcard = findViewById(R.id.bt_disconnectcard);
        bt_disconnectcard.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "disconnectcard";
                mHandler.sendMessage(msg);
            }
        });
        bt_readdata = findViewById(R.id.bt_readdata);
        bt_readdata.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "readdata";
                mHandler.sendMessage(msg);
            }
        });
        bt_readnumber = findViewById(R.id.bt_readnumber);
        bt_readnumber.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "readnumber";
                mHandler.sendMessage(msg);
            }
        });
        bt_readphoto = findViewById(R.id.bt_readphoto);
        bt_readphoto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "readphoto";
                mHandler.sendMessage(msg);
            }
        });
        bt_readAText = findViewById(R.id.bt_readAText);
        bt_readAText.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "readAText";
                mHandler.sendMessage(msg);
            }
        });
        bt_getlicenseinfo = findViewById(R.id.bt_getlicenseinfo);
        bt_getlicenseinfo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "getlicenseinfo";
                mHandler.sendMessage(msg);
            }
        });
        bt_cardinfo = findViewById(R.id.bt_cardinfo);
        bt_cardinfo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "cardinfo";
                mHandler.sendMessage(msg);
            }
        });
        bt_getrid = findViewById(R.id.bt_getrid);
        bt_getrid.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "getrid";
                mHandler.sendMessage(msg);
            }
        });
        bt_updatelicensefile = findViewById(R.id.bt_updatelicensefile);
        bt_updatelicensefile.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "updatelicensefile";
                mHandler.sendMessage(msg);
            }
        });
        bt_exit = findViewById(R.id.bt_exit);
        bt_exit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Message msg = mHandler.obtainMessage();
                msg.obj = "exit";
                mHandler.sendMessage(msg);
            }
        });


        NALibs.setListenerNA(responseListener);
        setResultText("setListenerNA" + "\n" + "------------------------------");

        /**************  Permission  *************/
        /*           Can remove "Manifest.permission.ACCESS_FINE_LOCATION" in array if use USB reader only            */

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.S) {
            ActivityCompat.requestPermissions(MainActivity.this, new String[]{Manifest.permission.BLUETOOTH_SCAN, Manifest.permission.BLUETOOTH_CONNECT}, MY_PERMISSIONS);
        } else {
            ActivityCompat.requestPermissions(MainActivity.this, new String[]{Manifest.permission.ACCESS_FINE_LOCATION}, MY_PERMISSIONS);
        }
        /*****************************************/

        writeLicFile(LicFile);

        Message msg = mHandler.obtainMessage();
        msg.obj = "openlib";
        mHandler.sendMessage(msg);
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        Message msg = mHandler.obtainMessage();
        msg.obj = "exit";
        mHandler.sendMessage(msg);
    }

    public void setResultText(final String text) {
        handler.post(new Runnable() {
            public void run() {
                tv_output.setText(tv_output.getText().toString() + "\n" + text);
                scrollView.post(new Runnable() {
                    @Override

                    public void run() {
                        scrollView.fullScroll(View.FOCUS_DOWN);

                    }
                });
            }
        });
    }

    public void setEnableButton() {
        runOnUiThread(new Runnable() {

            @Override
            public void run() {
                bt_cardinfo.setEnabled(true);
                bt_scanreader.setEnabled(true);
                bt_listoption.setEnabled(true);
                bt_selectreader.setEnabled(true);
                bt_deselectreader.setEnabled(true);
                bt_connectcard.setEnabled(true);
                bt_disconnectcard.setEnabled(true);
                bt_readdata.setEnabled(true);
                bt_readnumber.setEnabled(true);
                bt_readphoto.setEnabled(true);
                bt_getrid.setEnabled(true);
                bt_readAText.setEnabled(true);
                bt_getlicenseinfo.setEnabled(true);
                bt_updatelicensefile.setEnabled(true);
                bt_exit.setEnabled(true);
            }
        });
    }

    public void setDisableButton() {
        runOnUiThread(new Runnable() {

            @Override
            public void run() {
                bt_cardinfo.setEnabled(false);
                bt_scanreader.setEnabled(false);
                bt_listoption.setEnabled(false);
                bt_selectreader.setEnabled(false);
                bt_deselectreader.setEnabled(false);
                bt_connectcard.setEnabled(false);
                bt_disconnectcard.setEnabled(false);
                bt_readdata.setEnabled(false);
                bt_readnumber.setEnabled(false);
                bt_readphoto.setEnabled(false);
                bt_getrid.setEnabled(false);
                bt_readAText.setEnabled(false);
                bt_getlicenseinfo.setEnabled(false);
                bt_updatelicensefile.setEnabled(false);
                bt_exit.setEnabled(false);
            }
        });
    }

    public void writeLicFile(String Path) {
        AssetManager assetManager = getAssets();
        try {
            InputStream is = assetManager.open("rdnidlib.dls");
            File out = new File(Path);
            if (out.exists())
                return;
            File parent = new File(out.getParent());
            parent.mkdirs();
            byte[] buffer = new byte[1024];
            FileOutputStream fos = new FileOutputStream(out);
            int read;

            while ((read = is.read(buffer, 0, 1024)) >= 0) {
                fos.write(buffer, 0, read);
            }

            fos.flush();
            fos.close();
            is.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    class MyHandler extends Handler {
        MyHandler(Looper myLooper) {
            super(myLooper);
        }

        public void handleMessage(Message msg) {
            String message = (String) msg.obj;
            setDisableButton();
            switch (message) {
                case "openlib": {
                    Parameter_OpenLib = LicFile;

                    /*** set USB reader in-app permission ***/
                    /***
                     pms: 0 = Disable USB reader in-app permission (default).
                     pms: 1 = Enable USB reader in-app permission.
                     pms: -1 = Get current permissions state.
                     ***/

                    int pms = 1;
                    int resultpms = NALibs.setPermissionsNA(pms);
                    String Output = "setPermissionsNA(" + pms + ")" + "\n" + "   Return > " + resultpms;
                    Output = Output + "\n" + "------------------------------";
                    setResultText(Output);


                    NALibs.openLibNA(Parameter_OpenLib);
                    break;
                }
                case "getreaderlist": {
                    int ListOption = Integer.parseInt(bt_listoption.getText().toString().substring(bt_listoption.length() - 2, bt_listoption.length()).toLowerCase(), 16);
                    NALibs.getReaderListNA(ListOption);
                    break;
                }
                case "selectreader": {
                    nameDevice = "";
                    if (spinner.getChildCount() != 0) {
                        nameDevice = spinner.getSelectedItem().toString();
                    }
                    NALibs.selectReaderNA(nameDevice);
                    break;
                }
                case "deselectreader": {
                    int Result = NALibs.deselectReaderNA();
                    if (Result == 0) {
                        handler.post(new Runnable() {
                            public void run() {
                                tv_connected.setText("");
                                ll_connect.setBackgroundColor(RED);
                                tv_connected.setTextColor(WHITE);
                            }
                        });
                    }
                    String Output = "deselectReaderNA" + "\n" + "   Return > " + Result;
                    Output = Output + "\n" + "------------------------------";
                    setResultText(Output);
                    setEnableButton();
                    break;
                }
                case "connectcard": {
                    int Result = NALibs.connectCardNA();
                    String Output = "connectCardNA" + "\n" + "   Return > " + Result;
                    Output = Output + "\n" + "------------------------------";
                    setResultText(Output);
                    setEnableButton();
                    break;
                }
                case "disconnectcard": {
                    int Result = NALibs.disconnectCardNA();
                    String Output = "disconnectCardNA" + "\n" + "   Return > " + Result;
                    Output = Output + "\n" + "------------------------------";
                    setResultText(Output);
                    setEnableButton();
                    break;
                }
                case "readnumber": {
                    NALibs.getNIDNumberNA();
                    break;
                }
                case "readdata": {
                    MessegeText = "readdata";
                    int getTextOption = NA_NO_AText;
                    NALibs.getNIDTextNA(getTextOption);
                    break;
                }
                case "readphoto": {
                    handler.post(new Runnable() {
                        public void run() {
                            iv_faceimage.setImageResource(R.mipmap.nad);
                        }
                    });
                    NALibs.getNIDPhotoNA();
                    break;
                }
                case "readAText": {
                    MessegeText = "readAText";
                    int getTextOption = NA_AText;
                    NALibs.getNIDTextNA(getTextOption);
                    break;
                }
                case "getlicenseinfo": {
                    String[] data = new String[1];
                    int Result = NALibs.getLicenseInfoNA(data);
                    String Output = "getLicenseInfoNA" + "\n" + "   Return > " + Result;
                    if (Result == 0) {
                        Output = Output + "\n" + "   Result > " + data[0];
                    }
                    Output = Output + "\n" + "------------------------------";
                    setResultText(Output);
                    setEnableButton();
                    break;
                }
                case "cardinfo": {
                    int Result = NALibs.getCardStatusNA();
                    String Output = "getCardStatusNA" + "\n" + "   Return > " + Result;
                    Output = Output + "\n" + "------------------------------";
                    setResultText(Output);
                    setEnableButton();
                    break;
                }
                case "getrid": {
                    final byte[] Rid = new byte[256];
                    int result = NALibs.getRidNA(Rid);
                    StringBuilder hexString = new StringBuilder();
                    for (byte aRid : Rid) {
                        String h = Integer.toHexString(0xFF & aRid);
                        while (h.length() < 2)
                            h = "0" + h;
                        hexString.append(h + " ");
                    }
                    String Output = "";
                    if (result > 0) {
                        hexString.setLength((result * 3) - 1);
                        Output = "getRidNA" + "\n" + "   Return > " + result;
                        Output = Output + "\n" + "   Result > " + hexString.toString().toUpperCase();
                    } else {
                        Output = "getRidNA" + "\n" + "   Return > " + result;
                    }
                    Output = Output + "\n" + "------------------------------";
                    setResultText(Output);
                    setEnableButton();
                    break;
                }
                case "updatelicensefile": {
                    NALibs.updateLicenseFileNA();
                    break;
                }
                case "exit": {
                    int Result = NALibs.closeLibNA();
                    String Output = "closeLibNA" + "\n" + "   Return > " + Result;
                    Output = Output + "\n" + "------------------------------";
                    setResultText(Output);
                    System.exit(0);
                    setEnableButton();
                    break;
                }
            }
        }
    }

    class HexadecimalInputFilter implements InputFilter {

        private final boolean mUpperCase;

        public HexadecimalInputFilter(boolean forceUpperCase) {
            mUpperCase = forceUpperCase;
        }

        @Override
        public CharSequence filter(CharSequence source, int start, int end, Spanned dest, int dstart, int dend) {

            char[] cleanSequence = null;
            final int sequenceLen = end - start;
            int nextOpenSlot = 0;
            int i = start;

            if (sequenceLen <= 0) {
                return null;
            }

            for (; i < end; ++i) {
                final char testChar = source.charAt(i);
                final char testCharUpperCase = Character.toUpperCase(testChar);
                if (testCharUpperCase != 'A' &&
                        testCharUpperCase != 'B' &&
                        testCharUpperCase != 'C' &&
                        testCharUpperCase != 'D' &&
                        testCharUpperCase != 'E' &&
                        testCharUpperCase != 'F' &&
                        !Character.isDigit(testChar)) {
                    if (null == cleanSequence) {
                        cleanSequence = new char[sequenceLen];
                        TextUtils.getChars(source, start, i, cleanSequence, 0);
                    }
                } else if ((mUpperCase && testChar != testCharUpperCase) ||
                        (!mUpperCase && testChar == testCharUpperCase)) {
                    if (null == cleanSequence) {
                        cleanSequence = new char[sequenceLen];
                        TextUtils.getChars(source, start, i, cleanSequence, 0);
                    }
                    cleanSequence[nextOpenSlot++] = (mUpperCase) ? testCharUpperCase : Character.toLowerCase(testChar);
                } else if (null != cleanSequence) {
                    cleanSequence[nextOpenSlot++] = testCharUpperCase;
                } else {
                    ++nextOpenSlot;
                }
            }

            if (null != cleanSequence) {
                final String cleanString;
                if (nextOpenSlot >= sequenceLen) {
                    cleanString = String.valueOf(cleanSequence);
                } else {
                    cleanString = String.valueOf(cleanSequence, 0, nextOpenSlot);
                }

                if (source instanceof Spanned) {
                    final SpannableString cleanSpannable = new SpannableString(cleanString);
                    TextUtils.copySpansFrom((Spanned) source,
                            start, nextOpenSlot, null, cleanSpannable, 0);
                    return cleanSpannable;
                } else {
                    return cleanString;
                }
            } else {
                return null;
            }
        }
    }
}
